#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#include <math.h>
#include "pnglib/lodepng.h"

typedef unsigned short int ush_t;


int maxval(int *vector, int len) 
{
	int max = INT_MIN;
	for (--len; len >= 0; len--)
		if (vector[len] > max)
			max = vector[len];
	return (max);
}


/* Assuming we are on a PC (little endian), convert to big endian */
ush_t revbytes(ush_t x)
{
  return ( ((x & 0xFF) << 8) | (x >> 8) );
}


void savepng(char *fname, int *array, int w, int h)
{
	double c, scale = 1.0 / (double) maxval(array, w*h);
	int i, j;
	ush_t *rawimg = malloc(w*h*6); /* 3 channels (RGB), 16-bits per channel */
	
	if (!rawimg) return;
	
	for (i = 0; i < h; i++)
		for (j = 0; j < w; j++)
		{
			c = 65535 * sqrt((double)array[i*w+j] * scale); /* MAX USHORT = 65535 */
			rawimg[3*(i*w + j) + 0] = revbytes( (ush_t) (3*c/5) );
			rawimg[3*(i*w + j) + 1] = revbytes( (ush_t) (3*c/5) );
			rawimg[3*(i*w + j) + 2] = revbytes( (ush_t) c );
		};
	
	lodepng_encode_file(fname, (const unsigned char *) rawimg, w, h, LCT_RGB, 16);
	free(rawimg);
}
